Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® OLAP Java API Reference 10g Release 2 (10.2) B14348-02
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.olapi.metadata.mdm
Class MdmMetadataProvider

    java.lang.Object
      |
      +--oracle.olapi.metadata.BaseMetadataProvider
            |
            +--oracle.olapi.metadata.mdm.MdmMetadataProvider

public class MdmMetadataProvider
extends BaseMetadataProvider
implements MetadataProvider

An object that gives access to the metadata for a data store, assuming that the metadata supports the multidimensional model (MDM). For example, MDM is supported by Oracle OLAP metadata. You get an `MdmMetadataProvider` by calling the `getDefaultMetadataProvider` method of the `ExpressDataProvider` you are using.

To discover each `MdmObject` in the data store, you can perform the following steps to navigate through the metadata.

1. Call the `getRootSchema` method to retrieve the root `MdmSchema`. This is the top-level `MdmSchema` in what might be a nested arrangement of `MdmSchema` objects.
2. Call the `getMeasureDimension` method of the root `MdmSchema` to get the `MdmMeasureDimension`, which contains all of the `MdmMeasure` objects that this `MdmMetadataProvider` provides.
3. Call the `getDimensions` method of the `MdmSchema` to retrieve a `List` of the `MdmPrimaryDimension` objects, except for the `MdmMeasureDimension`, that the `MdmSchema` contains.
4. Call the `getHierarchies` method of each `MdmPrimaryDimension` objects returned by the `getDimensions` method to get the `MdmHierarchy` objects that the `MdmPrimaryDimension` contains.
5. For each `MdmPrimaryDimension` and `MdmHierarchy`, call its methods for discovering related objects, such as its `MdmAttribute` objects.
6. Call the `getSubSchemas` method of the `MdmSchema` to retrieve a `List` of the `MdmSchema` objects that it contains.
7. On each subschema, call its `getDimensions`, `getMeasures`, and `getSchemas` methods to discover the objects that it contains.
8. For each `MdmMeasure`, call the `getDimensions` method to discover its `MdmPrimaryDimension` objects.

When an application references metadata through an `MdmMetadataProvider`, Oracle OLAP retrieves information about the metadata and caches that information using the resources of the application. If the metadata in the data store changes, either through changes made in the Oracle OLAP metadata by a database administrator or by your application, then the cached information becomes obsolete. An application can call the `update` method to refresh the cached metadata. Optionally, after calling `update`, the application can call the `flushDeletedObjects` method to free the resources related to any deleted objects. Use the `update` and `flushDeletedObjects` methods if your applications has changed `MdmObject` objects that might be cached, or if a database administrator might change the data store.

Method Summary
`MdmCustomObjectFactory` | `getMdmCustomObjectFactory()` Gets an `MdmCustomObjectFactory`, which you can use to create custom objects, such as an `MdmMeasure` or `MdmDimension`, for this `MdmMetadataProvider`.
`MdmObject` | `getMetadataObject(java.lang.String id)` Gets the `MdmObject` that has the specified identifier.
`java.util.List` | `getMetadataObjects(java.lang.String[] ids)` Gets a `List` in which each element is an `MdmObject` that has one of the specified identifiers.
`MtmCustomObjectFactory` | `getMtmCustomObjectFactory()` Gets an `MtmCustomObjectFactory`, which you can use to create custom objects such as an `MtmBaseCube` or an `MtmSolveSpecification` for this `MdmMetadataProvider`.
`MdmSchema` | `getRootSchema()` Gets the top-level `MdmSchema` in the data store to which this `MdmMetadataProvider` gives access.
`void` | `setMdmNamingConvention(MdmNamingConvention convention)` Specifies the `MdmNamingConvention` that you want to use to produce names for custom ``BaseMetadataObject`` objects.

Methods inherited from class oracle.olapi.metadata.BaseMetadataProvider
`flushDeletedObjects, getDataProvider, getID, supportsMetadataUpdate, update`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getMetadataObject

    public final MdmObject getMetadataObject(java.lang.String id)
                                      throws ObjectClosedException

  Gets the `MdmObject` that has the specified identifier.
  Parameters:
    `id` - A `String` that uniquely identifies the `MdmMetadataObject` to be returned.
  Returns:
    The requested `MdmObject`.

### getMetadataObjects

    public final java.util.List getMetadataObjects(java.lang.String[] ids)
                                            throws ObjectClosedException

  Gets a `List` in which each element is an `MdmObject` that has one of the specified identifiers.
  Parameters:
    `id` - An array of `String` objects, each of which uniquely identifies an `MdmObject` to be returned.
  Returns:
    A `List` that contains an `MdmObject` for each of the specified identifiers.

### getRootSchema

    public MdmSchema getRootSchema()

  Gets the top-level `MdmSchema` in the data store to which this `MdmMetadataProvider` gives access.
  Returns:
    The top-level `MdmSchema` in the data store.

### getMdmCustomObjectFactory

    public final MdmCustomObjectFactory getMdmCustomObjectFactory()

  Gets an `MdmCustomObjectFactory`, which you can use to create custom objects, such as an `MdmMeasure` or `MdmDimension`, for this `MdmMetadataProvider`.
  Returns:
    An `MdmCustomObjectFactory` for this `MdmMetadataProvider`.

### getMtmCustomObjectFactory

    public final MtmCustomObjectFactory getMtmCustomObjectFactory()

  Gets an `MtmCustomObjectFactory`, which you can use to create custom objects such as an `MtmBaseCube` or an `MtmSolveSpecification` for this `MdmMetadataProvider`.
  Returns:
    An `MtmCustomObjectFactory` for this `MdmMetadataProvider`.

### setMdmNamingConvention

    public void setMdmNamingConvention(MdmNamingConvention convention)

  Specifies the `MdmNamingConvention` that you want to use to produce names for custom ``BaseMetadataObject`` objects.
  Parameters:
    `convention` - The `MdmNamingConvention` that you want to use to produce names for custom `BaseMetadataObject` objects.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® OLAP Java API Reference 10g Release 2 (10.2) B14348-02
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002, 2005, Oracle. All rights reserved.